import java.awt.image.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;
import java.io.File;
import javax.imageio.ImageIO;

public class PictureCanvas extends ScaleCanvas implements MouseListener, MouseMotionListener {
    Manager M;
    Complex[] CLOUD=new Complex[5000];
    Path2D.Double PATH;
    BufferedImage IMAGE;

     public PictureCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 setScales(10,490,480);
	 IMAGE = new BufferedImage(500,500,BufferedImage.TYPE_INT_RGB);
	 setRandom();
     }

    public void setRandom() {

	int k=20;
	int lim=1000;
	try{
           k=M.C.PACK.val+1;
	   lim=M.C.numberOfPoints();
	}

	catch(Exception e) {
	}
	
	double r=0.5*k/20;
	for(int i=0;i<lim;++i) {
	    double x=Math.random();
	    double y=Math.random();
	    x=2*x-1;
	    y=2*y-1;
	    x=.5+r*x;
	    y=.5+r*y;
	    CLOUD[i]=new Complex(x,y);
	}
    }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      if(M.C.VD.HALT==false) g.drawImage(IMAGE,0,0,null);
      drawAxes(g);
      drawPoints(g);
   }

    public void drawBG(Graphics2D g) {
	g.setColor(new Color(0,0,0));
        g.fillRect(0,0,getWidth(),getHeight()); 
    }

    public void drawAxes(Graphics2D g) {
	Path2D.Double p=new Path2D.Double();
	p.moveTo(0,0);
	p.lineTo(1,0);
	p.lineTo(1,1);
	p.lineTo(0,1);
	p.closePath();
	p=transform(p);
	g.setColor(new Color(100,100,140));
	g.draw(p);
    }


    public boolean inCell(Complex z) {
	int m=whichCell(z);
	if(m==0) return true;
	return false;
    }
    

    public int whichCell(Complex z) {
	int  lim=M.C.numberOfPoints();
	double min=10000;
	int index=-1;
	for(int i=0;i<lim;++i) {
	    double d=Complex.distWrap(z,CLOUD[i]);
	    if(d<min) {
		min=d;
		index=i;
	    }
	}
	return index;
    }

    


    /**fitting the object nicely*/

    public void drawPoints(Graphics2D g) {
	int k=10;
	int  lim=M.C.numberOfPoints();
	double r=.01*Math.pow(.9,k);
	for(int i=0;i<lim;++i) {
	    Complex z=CLOUD[i];
	    fillPoint(g,z,r,Color.white,16);
	}
    }



    public void mousePressed(MouseEvent e) { }
    public void mouseClicked(MouseEvent e) { 
	MouseData J=MouseData.process(e);
        if(J.mode==1)  scaleUp(J.X,0);
        if(J.mode==3)  scaleUp(J.X,1);
        if(J.mode==2)  {
	    SOURCE=unTransform(J.X);
	}
	M.repaint();
    }
     public void mouseReleased(MouseEvent e) {	 
     }

     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   

     public void mouseMoved(MouseEvent e) {}   
     public void mouseDragged(MouseEvent e) {
     }


}

